/**
 * Javascript functions used on many pages in ICDL website
 * Author: Hilary Hutchinson
**/

// hidden style for hiding images in book reader
if (!(navigator.appName == 'Microsoft Internet Explorer' && navigator.platform.substr(0,3)=='Mac')) {
  document.write('<style type="text/css">');
  document.write('<!--');
  document.write('.hiddenbook {visibility: hidden}');
  document.write('-->');
  document.write('</style>');
}


<!--
// skip javascript if error
window.onerror = stopError;
function stopError() {
return true;
}

// true if dhtml features accessible
var DHTML = (document.getElementById || document.all || document.layers);

// global variables
var gOverviewPageCt,gPageWidth,gPageHeight,gTwoPageView,gOverviewCellWidth,gOverviewCellHeight;
var gWindowWidth,gWindowHeight;
var gThumb4ScaleWidth,gThumb4ScaleHeight;
var gThumb5ScaleWidth,gThumb5ScaleHeight;
var gThumb4Width,gThumb4Height,gThumb5Width,gThumb5Height;
var gBookSize=-1;

// get a named object on the page
// from http://www.quirksmode.org/js/cross_dhtml.html
function getObj(name) {
  if (document.getElementById) {
  	this.obj = document.getElementById(name);
     	this.style = document.getElementById(name).style;
  }
  else if (document.all) {
	this.obj = document.all[name];
	this.style = document.all[name].style;
  }
  else if (document.layers) {
   	this.obj = document.layers[name];
   	this.style = document.layers[name];
  }
}

// decide if an element exists on the page
function isValidObj(name) {
  if (document.getElementById) {
  	return (document.getElementById(name)!=null); 
  }
  else if (document.all) {
	return (document.all[name]!=null);
  }
  else if (document.layers) {
   	return (document.layers[name]!=null);
  }
  return false;
}

// get the absolute page x position of obj
// from http://www.quirksmode.org/js/findpos.html
function findPosX(obj) {
  var curleft = 0;
  if (obj.offsetParent) {
	while (obj.offsetParent) {
	  curleft += obj.offsetLeft
	  obj = obj.offsetParent;
	}
  }
  else if (obj.x)
	curleft += obj.x;
  return curleft;
}

// get the absolute page y position of obj
// from http://www.quirksmode.org/js/findpos.html
function findPosY(obj) {
  var curtop = 0;
  if (obj.offsetParent) {
    while (obj.offsetParent) {
      curtop += obj.offsetTop
	obj = obj.offsetParent;
    }
  }
  else if (obj.y)
    curtop += obj.y;
  return curtop;
}

// capture arrow keys
function prevnextcapture(e,prev,next) {
var k = (e.which) ? e.which : e.keyCode;
if ((k == 37 || k ==57387) && prev !="") { 
  window.location=updateUrl(prev);
}
else if ((k == 39 || k == 57388) && next != "") {
  window.location=updateUrl(next);
}
}

// get window dimensions
function getWindowDim() {
  if (window.innerWidth) {
    gWindowWidth=window.innerWidth;
    gWindowHeight=window.innerHeight;
  }
  else { 
    gWindowWidth = document.body.clientWidth;
    gWindowHeight = document.body.clientHeight;
  }
}

// mouseover image action
function img_act(name,path) {
if (DHTML) {
  var img=new getObj(name);
  var src=img.obj.src;
  var imgstart=src.indexOf("images")+7;
  var imgend=src.indexOf(".gif");
  if (imgend>-1 && src.indexOf("gray")==-1) {
    var shortSrc=src.substring(imgstart,imgend);
    var imgOn=new Image();
    imgOn.src=path+shortSrc+"_over.gif";
    img.obj.src=imgOn.src;
  }
}
}

// mouseout image action
function img_inact(name,path) {
if (DHTML) {
  var img=new getObj(name);
  var src=img.obj.src;
  var imgstart=src.indexOf("images")+7;
  var imgend=src.indexOf("_over.gif");
  if (imgend>-1) {
    var shortSrc=src.substring(imgstart,imgend);
    var imgOff=new Image();
    imgOff.src=path+shortSrc+".gif";
    img.obj.src=imgOff.src;
  }
}
}

// mouse over for globe image
function mapmouseover(name,label) {
  if (DHTML) {
    var cont=new getObj(name);
    var contlabel=new getObj(label);
    if (cont && label) {
      cont.style.background="#eebb88";
      contlabel.style.display="block";
    }
  } 
}

// mouse out for globe image
function mapmouseout(name,label){
  if (DHTML) {
    var cont=new getObj(name);
    var contlabel=new getObj(label);
    if (cont && label) {
      cont.style.background="#ccddaa";
      label.style.display="none";
    }
  }
}

// set cursor focus to username field
function userNameFocus() {
 if (DHTML) {
    if (isValidObj('userForm')) {
      var uform=new getObj('userForm');
      uform.obj.username.focus();
    }
  }
}

// set cursor focus to keyword field
function keywordFocus() {
  if (DHTML) {
    if (isValidObj('searchForm')) {
      var sform=new getObj('searchForm');
      sform.obj.term.focus();
    }
  }
}

// resize pages on book overview page to fit on screen on reload
function resizeBookPagesOnReload(pct,pw,ph,tp) {
 gOverviewPageCt=pct;
 gPageWidth=pw;
 gPageHeight=ph;
 gOverviewCellWidth=pw;
 gOverviewCellHeight=ph;
 gTwoPageView=tp;
 resizeBookPages();
 window.onresize=resizeBookPages;
}

// resize pages on book overview page to fit on screen
function resizeBookPages() {
  // hide the caterpillar progress bar
  var cater=new getObj("caterpillar");
  if (cater) {
    cater.style.display="none";
    cater.style.visibility="hidden";
  }

  // get the window dimensions
  getWindowDim(); 

  // calculate the new image dimensions
  var leafCt=gOverviewPageCt;
  if (gTwoPageView)
    leafCt=(leafCt+4)/2;

  var spacerHeight=Math.sqrt(leafCt)*12;
  var usableWindowHeight=gWindowHeight-(220+spacerHeight);
 
  var windowAR = gWindowWidth / usableWindowHeight;
  var pageAR = gPageWidth/gPageHeight;
  
  if (gTwoPageView)
    pageAR = 2*pageAR; 

  var factor = windowAR / pageAR;
  var numCols = Math.round(Math.sqrt(leafCt* factor)+0.5);
  var numRows = Math.ceil(leafCt / numCols); 
 
  var gridAR = (numCols * pageAR) / numRows;

  if (gridAR > windowAR) {
	gOverviewCellWidth = gWindowWidth / numCols;
	gOverviewCellHeight = gOverviewCellWidth / pageAR;
  } 
  else {
	gOverviewCellHeight = usableWindowHeight/numRows;
	gOverviewCellWidth = gOverviewCellHeight * pageAR;
  }

  if (gTwoPageView) 
    gOverviewCellWidth/=2;
  
  // loop over all the images, resize them if necessary, and set them visible
  var doResize=(gOverviewCellWidth<=2*gPageWidth && gOverviewCellHeight<=2*gPageHeight);
  for (i=0; i<gOverviewPageCt; i++) {
    var imgname='page'+i;
    var img=new getObj(imgname);
    if (doResize) {
      img.obj.width=gOverviewCellWidth;
      img.obj.height=gOverviewCellHeight;
    }
    img.style.visibility='visible';
  }
}

// enlarge an image on mouseover on a book overview page
function enlargeImgMouseOver(imgname1,imgname2) {
  // get new width/height
  var newwidth=gPageWidth*150/gPageHeight;
  var newheight=150;

  if (DHTML && newwidth>=1.5*gOverviewCellWidth) {
    // get left position of mouseover img
    var newleft=getLeftSideOfEnlargeImg(imgname1,imgname2,newwidth);    

    // get top position of mouseover img
    var img1=new getObj(imgname1);
    var imgtop=findPosY(img1.obj);
    var newtop; 

    if (imgtop+gOverviewCellHeight+newheight+15<gWindowHeight)
       newtop=imgtop+gOverviewCellHeight+5;
    else
       newtop=imgtop-(newheight+15);
   
    // get mouseover img 1
    enlargeImg(img1,'hiddenimg1',newwidth,newheight);

    // get mouseover img 2
    if (imgname2!='') {
      var img2=new getObj(imgname2);
      enlargeImg(img2,'hiddenimg2',newwidth,newheight);
    }

    // hide mouseover img 2 if none
    else {
      var img2=new getObj('hiddenimg2');
      img2.obj.width=0+'px';
      img2.obj.height=0+'px';
    }
    
    // position mouseover img 
    var hiddenImgDiv=new getObj('hiddenimgdiv');
    hiddenImgDiv.style.top=newtop+'px';
    hiddenImgDiv.style.left=newleft+'px';
    hiddenImgDiv.style.background='black';

    // position shadow img 
    var shadowImgDiv=new getObj('shadowimgdiv');
    shadowImgDiv.style.top=(newtop+8)+'px';
    shadowImgDiv.style.left=(newleft+8)+'px';
    if (imgname2!='') 
      shadowImgDiv.style.width=(2*newwidth+8)+'px';
    else
      shadowImgDiv.style.width=(newwidth+8)+'px';
    shadowImgDiv.style.height=(newheight+8)+'px';

    // make imgs visible
    shadowImgDiv.style.visibility='visible';
    hiddenImgDiv.style.visibility='visible';
  }
}

// find the left side of the mouseover img to display based on window dimensions
function getLeftSideOfEnlargeImg(imgname1,imgname2,newwidth) {
    var img1=new getObj(imgname1);
    var left=findPosX(img1.obj);
    var newleft;

    // two images
    if (imgname2!='') {
      var img2=new getObj(imgname2);
      var img2left=findPosX(img2.obj);

      // rtl book
      if (img2left<left) {
        left=left+gOverviewCellWidth-(2*newwidth+20);
        if (left>20)
          newleft=left;
        else
          newleft=img2left+20;
      }
      // ltr book
      else {
        if (left+(2*newwidth)+40<gWindowWidth)
          newleft=left+20;
        else
          newleft=gWindowWidth-(2*newwidth+50);
      }
    }
    // one image
    else {
      if (left+newwidth+40<gWindowWidth)
        newleft=left+20;
      else
        newleft=gWindowWidth-(newwidth+50);
    }
    return newleft;
}

// actual enlargement of image on book overview page
function enlargeImg(oldimg,hiddenimg,newwidth,newheight) {
    var newimg=new Image();
    var oldsrc=oldimg.obj.src;
    var thumbs=oldsrc.indexOf('thumbs')+7;
    var frag=oldsrc.substring(0,thumbs+22);
    newimg.src=frag+'thumb3.jpg';
    var hiddenImg=new getObj(hiddenimg);
    hiddenImg.obj.src=newimg.src;
    hiddenImg.obj.width=newwidth;
    hiddenImg.obj.height=newheight;
}

// hide enlarged images from mouseover on book overview page
function enlargeImgMouseOut(emptyimgname) {
  if (DHTML) {
    // hide images and shadow
    var hiddenImgDiv=new getObj('hiddenimgdiv');
    hiddenImgDiv.style.visibility='hidden';
    var shadowImgDiv=new getObj('shadowimgdiv');
    shadowImgDiv.style.visibility='hidden';

    hideImage('hiddenimg1',emptyimgname);
    hideImage('hiddenimg2',emptyimgname);
  }
}

// set mouseover image back to blank on enlarge image mouseover
function hideImage(hiddenimgname,emptyimgname) {
    var hiddenImg=new getObj(hiddenimgname);
    hiddenImg.style.background='white';
}

// initialize the dimensions of a book on a book page
function setBookPageDim(w4,h4,w5,h5,s) {
if (gBookSize==-1) {
  gBookSize=s;
  gThumb4Width=w4;
  gThumb4Height=h4;
  gThumb5Width=w5;
  gThumb5Height=h5;
  gThumb5ScaleWidth=w5*.6;
  gThumb5ScaleHeight=h5*.6;

  getWindowDim();
  getScaleDim();

  if (gBookSize==0)
    scaleImage();
}
}

// resize book page image on reload
function setResizing() {
window.onresize=scaleImage;
}

// get dimensions of book scaled to fit in window
function getScaleDim() {
  var locWindowWidth=gWindowWidth-20;
  var locWindowHeight=gWindowHeight-150;

  if (document.images['Image2']) {
    locWindowWidth/=2;
  }

  gThumb4ScaleWidth=gThumb4Width;
  gThumb4ScaleHeight=gThumb4Height;
  gThumb4ScaleHeight*=(locWindowWidth/gThumb4ScaleWidth);
  gThumb4ScaleWidth=locWindowWidth;
  if (gThumb4ScaleHeight>locWindowHeight) {
    gThumb4ScaleWidth*=(locWindowHeight/gThumb4ScaleHeight);
    gThumb4ScaleHeight=locWindowHeight;
  }
  if (gThumb4ScaleWidth>=gThumb4Width || gThumb4ScaleHeight >=gThumb4Height) {
    gThumb4ScaleWidth=gThumb4Width;
    gThumb4ScaleHeight=gThumb4Height;
  }
}

// change the size of the book pages
function changePageDim(w,h) {
  document.images['Image1'].width=w;
  document.images['Image1'].height=h;
  if (document.images['Image2']) {
     document.images['Image2'].width=w;
     document.images['Image2'].height=h;
  }
}

// change the resolution of the book pages
function changePageRes(oldsize,newsize) {
  var oldimg1=document.images['Image1'].src;
  var newimg1=new Image();
  newimg1.src=oldimg1.replace(oldsize,newsize);
  document.images['Image1'].src=newimg1.src;
  if (document.images['Image2']) {
     var oldimg2=document.images['Image2'].src;
     var newimg2=new Image();
     newimg2.src=oldimg2.replace(oldsize,newsize);
     document.images['Image2'].src=newimg2.src;
  }
}

// zoom in on a book page
function zoom_in() {
// if image is scaled down, bump it up
if (gBookSize==0 && gThumb4Width>gThumb4ScaleWidth) {
  gBookSize=1;
  changePageDim(gThumb4Width,gThumb4Height);
}

// if image is full size, go up to thumb 5
else if (gBookSize==0 || gBookSize==1) {
  gBookSize=2;
  changePageDim(gThumb5ScaleWidth,gThumb5ScaleHeight);
  changePageRes('thumb4','thumb5');
}

// if thumb5, rescale thumb 5
else if (gBookSize==2) {
  gBookSize=3;
  changePageDim(gThumb5Width,gThumb5Height);
  var grayOut=new Image();
  var zoomIn=document.images['zoomin'].src;
  grayOut.src=zoomIn.replace('zoomin_over','zoomin_gray');
  if (grayOut.src.indexOf('zoomin_gray')==-1)
    grayOut.src=grayOut.src.replace('zoomin','zoomin_gray');
  document.images['zoomin'].src=grayOut.src;
}
return false;
}

// zoom out on a book page
function zoom_out(ourl) {
// full size thumb4 bigger than window
if (gBookSize==1 && gThumb4Width>gThumb4ScaleWidth) {
  gBookSize=0;
  scaleImage();
}
// full size thumb4 smaller than window
else if (gBookSize==0 || gBookSize==1) {
    location.href=ourl;
}

else if (gBookSize==2) {
  gBookSize=1;
  changePageDim(gThumb4Width,gThumb4Height);
  changePageRes('thumb5','thumb4');
}
else if (gBookSize==3) {
  gBookSize=2;
  changePageDim(gThumb5ScaleWidth,gThumb5ScaleHeight);
  var zoomIn=new Image();
  var grayOut=document.images['zoomin'].src;
  zoomIn.src=grayOut.replace('zoomin_gray','zoomin');
  document.images['zoomin'].src=zoomIn.src;
}
return false;
}

// scale book page image on load
function scaleImage() {
  if (gBookSize==0) {
    getWindowDim();
    getScaleDim();
    if (gThumb4ScaleWidth>=200 && gThumb4ScaleHeight>=200) 
      changePageDim(gThumb4ScaleWidth,gThumb4ScaleHeight);
  }
}

// update url to contain current page size
function updateUrl(url) {
  var start=url.indexOf('size=');
  var shorturl=url.substring(start);
  var end=shorturl.indexOf('&');
  if (end==-1)
    end=shorturl.length;
  var currsize=shorturl.substring(0,end);
  var newsize='size='+gBookSize;
  return url.replace(currsize,newsize);
}

// change size of page when paging to new page
function changeSize(url) {
  if (url) {
    location.href=updateUrl(url);
    return false;
  }
}

//-->